/*
    Copyright (c) 2008-2010, Alexis Royer, http://alexis.royer.free.fr/Watch

    All rights reserved.

    Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:

        * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.
        * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.
        * Neither the name of the Watch project nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
    "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
    LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
    A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR
    CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
    EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
    LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
    NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
    SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/

package watch;


class EditorXmlConfigFile {
    void xml2model(java.io.File J_XmlFile, watch.EditorConfigFile W_ConfigFile) throws java.lang.Exception {
        javax.xml.parsers.DocumentBuilderFactory xml_Factory = javax.xml.parsers.DocumentBuilderFactory.newInstance();
        javax.xml.parsers.DocumentBuilder xml_Parser = xml_Factory.newDocumentBuilder();
        org.w3c.dom.Document xml_Doc = xml_Parser.parse(new java.io.FileInputStream(J_XmlFile));
        org.w3c.dom.Node xml_CurrentNodeid4489627 = xml_Doc.getFirstChild();
        Xml2Model_T_ConfigNode(xml_CurrentNodeid4489627, W_ConfigFile);
    }

    void Xml2Model_T_ConfigNode(org.w3c.dom.Node xml_FocusNodeid4488834, watch.EditorConfigFile W_ConfigFile) {
        Trace.println("Xml2Model_T_ConfigNode()");
        org.w3c.dom.Node xml_CurrentNodeid4488834 = xml_FocusNodeid4488834;

        for (int i_Attrid4488834 = 0; i_Attrid4488834 < xml_FocusNodeid4488834.getAttributes().getLength(); i_Attrid4488834 ++) {
            xml_CurrentNodeid4488834 = xml_FocusNodeid4488834.getAttributes().item(i_Attrid4488834);
            Trace.println("found attribute '" + xml_CurrentNodeid4488834.getNodeName() + "'");
            if (false) {
            }
            xml_CurrentNodeid4488834 = xml_FocusNodeid4488834;
        }



        for (int i_Childid4488834 = 0; i_Childid4488834 < xml_FocusNodeid4488834.getChildNodes().getLength(); i_Childid4488834 ++) {
            xml_CurrentNodeid4488834 = xml_FocusNodeid4488834.getChildNodes().item(i_Childid4488834);
            if (xml_CurrentNodeid4488834.getNodeType() == org.w3c.dom.Node.TEXT_NODE) continue;
            if (false) {
            } else if (xml_CurrentNodeid4488834.getNodeName().equals("paths")) {
                org.w3c.dom.Node xml_FocusNodeid4487980 = xml_CurrentNodeid4488834;
                org.w3c.dom.Node xml_CurrentNodeid4487980 = xml_FocusNodeid4487980;

                for (int i_Attrid4487980 = 0; i_Attrid4487980 < xml_FocusNodeid4487980.getAttributes().getLength(); i_Attrid4487980 ++) {
                    xml_CurrentNodeid4487980 = xml_FocusNodeid4487980.getAttributes().item(i_Attrid4487980);
                    Trace.println("found attribute '" + xml_CurrentNodeid4487980.getNodeName() + "'");
                    if (false) {
                    }
                    xml_CurrentNodeid4487980 = xml_FocusNodeid4487980;
                }



                for (int i_Childid4487980 = 0; i_Childid4487980 < xml_FocusNodeid4487980.getChildNodes().getLength(); i_Childid4487980 ++) {
                    xml_CurrentNodeid4487980 = xml_FocusNodeid4487980.getChildNodes().item(i_Childid4487980);
                    if (xml_CurrentNodeid4487980.getNodeType() == org.w3c.dom.Node.TEXT_NODE) continue;
                    if (false) {
                    } else if (xml_CurrentNodeid4487980.getNodeName().equals("last-directory")) {
                        org.w3c.dom.Node xml_FocusNodeid4487602 = xml_CurrentNodeid4487980;
                        org.w3c.dom.Node xml_CurrentNodeid4487602 = xml_FocusNodeid4487602;

                        for (int i_Attrid4487602 = 0; i_Attrid4487602 < xml_FocusNodeid4487602.getAttributes().getLength(); i_Attrid4487602 ++) {
                            xml_CurrentNodeid4487602 = xml_FocusNodeid4487602.getAttributes().item(i_Attrid4487602);
                            Trace.println("found attribute '" + xml_CurrentNodeid4487602.getNodeName() + "'");
                            if (false) {
                            } else if (xml_CurrentNodeid4487602.getNodeName().equals("path")) {
                                W_ConfigFile.setLastDirectory(xml_CurrentNodeid4487602.getTextContent());
                            }
                            xml_CurrentNodeid4487602 = xml_FocusNodeid4487602;
                        }



                        for (int i_Childid4487602 = 0; i_Childid4487602 < xml_FocusNodeid4487602.getChildNodes().getLength(); i_Childid4487602 ++) {
                            xml_CurrentNodeid4487602 = xml_FocusNodeid4487602.getChildNodes().item(i_Childid4487602);
                            if (xml_CurrentNodeid4487602.getNodeType() == org.w3c.dom.Node.TEXT_NODE) continue;
                            if (false) {
                            }
                            xml_CurrentNodeid4487602 = xml_FocusNodeid4487602;
                        }

                    } else if (xml_CurrentNodeid4487980.getNodeName().equals("current-input-file")) {
                        org.w3c.dom.Node xml_FocusNodeid4485835 = xml_CurrentNodeid4487980;
                        org.w3c.dom.Node xml_CurrentNodeid4485835 = xml_FocusNodeid4485835;

                        for (int i_Attrid4485835 = 0; i_Attrid4485835 < xml_FocusNodeid4485835.getAttributes().getLength(); i_Attrid4485835 ++) {
                            xml_CurrentNodeid4485835 = xml_FocusNodeid4485835.getAttributes().item(i_Attrid4485835);
                            Trace.println("found attribute '" + xml_CurrentNodeid4485835.getNodeName() + "'");
                            if (false) {
                            } else if (xml_CurrentNodeid4485835.getNodeName().equals("path")) {
                                W_ConfigFile.setCurrentInputFile(xml_CurrentNodeid4485835.getTextContent());
                            }
                            xml_CurrentNodeid4485835 = xml_FocusNodeid4485835;
                        }



                        for (int i_Childid4485835 = 0; i_Childid4485835 < xml_FocusNodeid4485835.getChildNodes().getLength(); i_Childid4485835 ++) {
                            xml_CurrentNodeid4485835 = xml_FocusNodeid4485835.getChildNodes().item(i_Childid4485835);
                            if (xml_CurrentNodeid4485835.getNodeType() == org.w3c.dom.Node.TEXT_NODE) continue;
                            if (false) {
                            }
                            xml_CurrentNodeid4485835 = xml_FocusNodeid4485835;
                        }

                    }
                    xml_CurrentNodeid4487980 = xml_FocusNodeid4487980;
                }

            } else if (xml_CurrentNodeid4488834.getNodeName().equals("projects")) {
                org.w3c.dom.Node xml_FocusNodeid4482454 = xml_CurrentNodeid4488834;
                org.w3c.dom.Node xml_CurrentNodeid4482454 = xml_FocusNodeid4482454;

                for (int i_Attrid4482454 = 0; i_Attrid4482454 < xml_FocusNodeid4482454.getAttributes().getLength(); i_Attrid4482454 ++) {
                    xml_CurrentNodeid4482454 = xml_FocusNodeid4482454.getAttributes().item(i_Attrid4482454);
                    Trace.println("found attribute '" + xml_CurrentNodeid4482454.getNodeName() + "'");
                    if (false) {
                    }
                    xml_CurrentNodeid4482454 = xml_FocusNodeid4482454;
                }



                for (int i_Childid4482454 = 0; i_Childid4482454 < xml_FocusNodeid4482454.getChildNodes().getLength(); i_Childid4482454 ++) {
                    xml_CurrentNodeid4482454 = xml_FocusNodeid4482454.getChildNodes().item(i_Childid4482454);
                    if (xml_CurrentNodeid4482454.getNodeType() == org.w3c.dom.Node.TEXT_NODE) continue;
                    if (false) {
                    } else if (xml_CurrentNodeid4482454.getNodeName().equals("project")) {
                        org.w3c.dom.Node xml_FocusNodeid4482741 = xml_CurrentNodeid4482454;
                        org.w3c.dom.Node xml_CurrentNodeid4482741 = xml_FocusNodeid4482741;

                        for (int i_Attrid4482741 = 0; i_Attrid4482741 < xml_FocusNodeid4482741.getAttributes().getLength(); i_Attrid4482741 ++) {
                            xml_CurrentNodeid4482741 = xml_FocusNodeid4482741.getAttributes().item(i_Attrid4482741);
                            Trace.println("found attribute '" + xml_CurrentNodeid4482741.getNodeName() + "'");
                            if (false) {
                            } else if (xml_CurrentNodeid4482741.getNodeName().equals("path")) {
                                W_ConfigFile.getProjects().add(xml_CurrentNodeid4482741.getTextContent());
                            }
                            xml_CurrentNodeid4482741 = xml_FocusNodeid4482741;
                        }



                        for (int i_Childid4482741 = 0; i_Childid4482741 < xml_FocusNodeid4482741.getChildNodes().getLength(); i_Childid4482741 ++) {
                            xml_CurrentNodeid4482741 = xml_FocusNodeid4482741.getChildNodes().item(i_Childid4482741);
                            if (xml_CurrentNodeid4482741.getNodeType() == org.w3c.dom.Node.TEXT_NODE) continue;
                            if (false) {
                            }
                            xml_CurrentNodeid4482741 = xml_FocusNodeid4482741;
                        }

                    }
                    xml_CurrentNodeid4482454 = xml_FocusNodeid4482454;
                }

            } else if (xml_CurrentNodeid4488834.getNodeName().equals("window")) {
                org.w3c.dom.Node xml_FocusNodeid4490020 = xml_CurrentNodeid4488834;
                org.w3c.dom.Node xml_CurrentNodeid4490020 = xml_FocusNodeid4490020;

                for (int i_Attrid4490020 = 0; i_Attrid4490020 < xml_FocusNodeid4490020.getAttributes().getLength(); i_Attrid4490020 ++) {
                    xml_CurrentNodeid4490020 = xml_FocusNodeid4490020.getAttributes().item(i_Attrid4490020);
                    Trace.println("found attribute '" + xml_CurrentNodeid4490020.getNodeName() + "'");
                    if (false) {
                    } else if (xml_CurrentNodeid4490020.getNodeName().equals("maximized")) {
                        if (xml_CurrentNodeid4490020.getTextContent().equals("true")) {
                            W_ConfigFile.setWindowIsMaximized(true);
                        }
                        if (xml_CurrentNodeid4490020.getTextContent().equals("false")) {
                            W_ConfigFile.setWindowIsMaximized(false);
                        }
                    } else if (xml_CurrentNodeid4490020.getNodeName().equals("x")) {
                        W_ConfigFile.setWindowX(new Integer(xml_CurrentNodeid4490020.getTextContent()));
                    } else if (xml_CurrentNodeid4490020.getNodeName().equals("y")) {
                        W_ConfigFile.setWindowY(new Integer(xml_CurrentNodeid4490020.getTextContent()));
                    } else if (xml_CurrentNodeid4490020.getNodeName().equals("width")) {
                        W_ConfigFile.setWindowWidth(new Integer(xml_CurrentNodeid4490020.getTextContent()));
                    } else if (xml_CurrentNodeid4490020.getNodeName().equals("height")) {
                        W_ConfigFile.setWindowHeight(new Integer(xml_CurrentNodeid4490020.getTextContent()));
                    }
                    xml_CurrentNodeid4490020 = xml_FocusNodeid4490020;
                }



                for (int i_Childid4490020 = 0; i_Childid4490020 < xml_FocusNodeid4490020.getChildNodes().getLength(); i_Childid4490020 ++) {
                    xml_CurrentNodeid4490020 = xml_FocusNodeid4490020.getChildNodes().item(i_Childid4490020);
                    if (xml_CurrentNodeid4490020.getNodeType() == org.w3c.dom.Node.TEXT_NODE) continue;
                    if (false) {
                    }
                    xml_CurrentNodeid4490020 = xml_FocusNodeid4490020;
                }

            }
            xml_CurrentNodeid4488834 = xml_FocusNodeid4488834;
        }

        Trace.println("Xml2Model_T_ConfigNode() ->");
    }

    protected static class Display {
        public static void println(String J_Text) {
            System.out.println(J_Text);
        }
    }
    protected static class Trace {
        public static void println(String J_Text) {
        }
        public static void printStackTrace(Exception e) {
            e.printStackTrace();
        }
    }
    protected String xpath(org.w3c.dom.Node XML_Node, String J_Expression) {
        try {
            javax.xml.xpath.XPathFactory xml_Factory = javax.xml.xpath.XPathFactory.newInstance();
            javax.xml.xpath.XPath xml_XPath = xml_Factory.newXPath();
            String j_Res = xml_XPath.evaluate(J_Expression, XML_Node);
            return j_Res;
        } catch (Exception j_Exception) {
            Trace.printStackTrace(j_Exception);
            return new String();
        }
    }

    void model2xml(java.io.File J_XmlFile, watch.EditorConfigFile W_ConfigFile) throws java.lang.Exception {
        javax.xml.parsers.DocumentBuilderFactory xml_BuilderFactory = javax.xml.parsers.DocumentBuilderFactory.newInstance();
        javax.xml.parsers.DocumentBuilder xml_Builder = xml_BuilderFactory.newDocumentBuilder();
        org.w3c.dom.Document xml_Doc = xml_Builder.newDocument();
        org.w3c.dom.Element xml_CurrentNodeid4489627 = xml_Doc.createElement("config");
        xml_Doc.appendChild(xml_CurrentNodeid4489627);
        Model2Xml_T_ConfigNode(xml_CurrentNodeid4489627, W_ConfigFile);
        javax.xml.transform.TransformerFactory xsl_Factory = javax.xml.transform.TransformerFactory.newInstance();
        javax.xml.transform.Transformer xsl_Transformer = xsl_Factory.newTransformer();
        xsl_Transformer.setOutputProperty(javax.xml.transform.OutputKeys.INDENT, "yes");
        xsl_Transformer.setOutputProperty(javax.xml.transform.OutputKeys.ENCODING, "ISO-8859-1");
        javax.xml.transform.dom.DOMSource xml_Source = new javax.xml.transform.dom.DOMSource(xml_Doc);
        javax.xml.transform.stream.StreamResult xml_Result = new javax.xml.transform.stream.StreamResult(new java.io.FileOutputStream(J_XmlFile));
        xsl_Transformer.transform(xml_Source, xml_Result);
    }

    void Model2Xml_T_ConfigNode(org.w3c.dom.Node xml_FocusNodeid4488834, watch.EditorConfigFile W_ConfigFile) {
        Trace.println("Model2Xml_T_ConfigNode()");
        org.w3c.dom.Node xml_CurrentNodeid4488834 = xml_FocusNodeid4488834;

        xml_CurrentNodeid4488834 = xml_FocusNodeid4488834;


        if (true) {
            xml_CurrentNodeid4488834 = createNode(xml_FocusNodeid4488834, "paths");
            org.w3c.dom.Node xml_FocusNodeid4487980 = xml_CurrentNodeid4488834;
            org.w3c.dom.Node xml_CurrentNodeid4487980 = xml_FocusNodeid4487980;

            xml_CurrentNodeid4487980 = xml_FocusNodeid4487980;


            if (true) {
                xml_CurrentNodeid4487980 = createNode(xml_FocusNodeid4487980, "last-directory");
                org.w3c.dom.Node xml_FocusNodeid4487602 = xml_CurrentNodeid4487980;
                org.w3c.dom.Node xml_CurrentNodeid4487602 = xml_FocusNodeid4487602;

                if (true) {
                    xml_CurrentNodeid4487602 = createAttribute(xml_FocusNodeid4487602, "path");
                    xml_CurrentNodeid4487602.setTextContent(String.valueOf(W_ConfigFile.getLastDirectory()));
                }
                xml_CurrentNodeid4487602 = xml_FocusNodeid4487602;



            }
            if (true) {
                xml_CurrentNodeid4487980 = createNode(xml_FocusNodeid4487980, "current-input-file");
                org.w3c.dom.Node xml_FocusNodeid4485835 = xml_CurrentNodeid4487980;
                org.w3c.dom.Node xml_CurrentNodeid4485835 = xml_FocusNodeid4485835;

                if (true) {
                    xml_CurrentNodeid4485835 = createAttribute(xml_FocusNodeid4485835, "path");
                    xml_CurrentNodeid4485835.setTextContent(String.valueOf(W_ConfigFile.getSafeCurrentInputFile()));
                }
                xml_CurrentNodeid4485835 = xml_FocusNodeid4485835;



            }
            xml_CurrentNodeid4487980 = xml_FocusNodeid4487980;

        }
        if (true) {
            xml_CurrentNodeid4488834 = createNode(xml_FocusNodeid4488834, "projects");
            org.w3c.dom.Node xml_FocusNodeid4482454 = xml_CurrentNodeid4488834;
            org.w3c.dom.Node xml_CurrentNodeid4482454 = xml_FocusNodeid4482454;

            xml_CurrentNodeid4482454 = xml_FocusNodeid4482454;


            for (java.util.Iterator<String> j_ProjectIt = W_ConfigFile.getProjects().iterator(); j_ProjectIt.hasNext(); ) {
                if (true) {
                    xml_CurrentNodeid4482454 = createNode(xml_FocusNodeid4482454, "project");
                    org.w3c.dom.Node xml_FocusNodeid4482741 = xml_CurrentNodeid4482454;
                    org.w3c.dom.Node xml_CurrentNodeid4482741 = xml_FocusNodeid4482741;

                    if (true) {
                        xml_CurrentNodeid4482741 = createAttribute(xml_FocusNodeid4482741, "path");
                        xml_CurrentNodeid4482741.setTextContent(String.valueOf(j_ProjectIt.next()));
                    }
                    xml_CurrentNodeid4482741 = xml_FocusNodeid4482741;



                }
            }
            xml_CurrentNodeid4482454 = xml_FocusNodeid4482454;

        }
        if (true) {
            xml_CurrentNodeid4488834 = createNode(xml_FocusNodeid4488834, "window");
            org.w3c.dom.Node xml_FocusNodeid4490020 = xml_CurrentNodeid4488834;
            org.w3c.dom.Node xml_CurrentNodeid4490020 = xml_FocusNodeid4490020;

            if (true) {
                xml_CurrentNodeid4490020 = createAttribute(xml_FocusNodeid4490020, "maximized");
                if (W_ConfigFile.getWindowIsMaximized()) {
                    xml_CurrentNodeid4490020.setTextContent("true");
                } else {
                    xml_CurrentNodeid4490020.setTextContent("false");
                }
            }
            if (true) {
                xml_CurrentNodeid4490020 = createAttribute(xml_FocusNodeid4490020, "x");
                xml_CurrentNodeid4490020.setTextContent(String.valueOf(W_ConfigFile.getWindowX()));
            }
            if (true) {
                xml_CurrentNodeid4490020 = createAttribute(xml_FocusNodeid4490020, "y");
                xml_CurrentNodeid4490020.setTextContent(String.valueOf(W_ConfigFile.getWindowY()));
            }
            if (true) {
                xml_CurrentNodeid4490020 = createAttribute(xml_FocusNodeid4490020, "width");
                xml_CurrentNodeid4490020.setTextContent(String.valueOf(W_ConfigFile.getWindowWidth()));
            }
            if (true) {
                xml_CurrentNodeid4490020 = createAttribute(xml_FocusNodeid4490020, "height");
                xml_CurrentNodeid4490020.setTextContent(String.valueOf(W_ConfigFile.getWindowHeight()));
            }
            xml_CurrentNodeid4490020 = xml_FocusNodeid4490020;



        }
        xml_CurrentNodeid4488834 = xml_FocusNodeid4488834;

        Trace.println("Model2Xml_T_ConfigNode() ->");
    }

    protected org.w3c.dom.Element createNode(org.w3c.dom.Node XML_Node, String J_NodeName) {
        try {
            org.w3c.dom.Document xml_Doc = XML_Node.getOwnerDocument();
            org.w3c.dom.Element xml_CurrentNode = xml_Doc.createElement(J_NodeName);
            XML_Node.appendChild(xml_CurrentNode);
            return xml_CurrentNode;
        } catch (Exception j_Exception) {
            Trace.printStackTrace(j_Exception);
            return null;
        }
    }

    protected org.w3c.dom.Attr createAttribute(org.w3c.dom.Node XML_Node, String J_AttributeName) {
        try {
            org.w3c.dom.Document xml_Doc = XML_Node.getOwnerDocument();
            org.w3c.dom.Attr xml_Attribute = xml_Doc.createAttribute(J_AttributeName);
            XML_Node.getAttributes().setNamedItem(xml_Attribute);
            return xml_Attribute;
        } catch (Exception j_Exception) {
            Trace.printStackTrace(j_Exception);
            return null;
        }
    }

}
